# -*- encoding: utf-8 -*-
# stub: chef-berksfile-env 1.5.0 ruby lib

Gem::Specification.new do |s|
  s.name = "chef-berksfile-env".freeze
  s.version = "1.5.0"

  s.required_rubygems_version = Gem::Requirement.new(">= 0".freeze) if s.respond_to? :required_rubygems_version=
  s.require_paths = ["lib".freeze]
  s.authors = ["Bryan Baugher".freeze]
  s.date = "2018-05-04"
  s.description = "Chef-Berksfile-Env\n==================\n\nA Chef plugin which allows you to lock down your Chef Environment's cookbook versions with a Berksfile.\n\nThis is effectively the same as doing `berks apply ...` but via `knife environment from file ...`.\n\nView the [Change Log](https://github.com/bbaugher/chef-berksfile-env/blob/master/CHANGELOG.md) to see what has changed.\n\nInstallation\n------------\n\n    /opt/chef/embedded/bin/gem install chef-berksfile-env\n\nUsage\n-----\n\nIn your chef repo create a Berksfile next to your Chef environment file like this,\n\n    chef-repo/environments/[ENV_NAME]/Berksfile\n\nThis is the default location that will used by the plugin. We have to put the Berksfile in its own\ndirectory since [multiple Berksfiles can't exist in the same directory](https://github.com/berkshelf/berkshelf/issues/1247). \n\nThe berksfile should include any cookbooks that your nodes or roles explicitly mention for that environment,\n\n    source \"https://supermarket.getchef.com\"\n\n    cookbook \"java\"\n    cookbook \"yum\", \"~> 2.0\"\n    ...\n\nNext we need to generate our Berksfile's lock file,\n\n    berks install\n\nYour environment file must by in `.rb` format and look like this,\n\n    require 'chef-berksfile-env'\n    \n    # The name must be defined first so we can use it to find the Berksfile\n    name \"my_env\"\n    \n    # Load Berksfile locked dependencies as my environment's cookbook version contraints\n    load_berksfile\n\n    ...\n\nNow our environment will use the locked versions of the cookbooks and transitive dependencies generated by our Berksfile. \nUpgrading to the latest dependecies is now as simple as,\n\n    berks install\n\nOur Berksfile also provides an easy way to ensure all the cookbooks and their versions that our environment requires \nare uploaded to our chef-server,\n\n    berks upload\n\nHow the Plugin Finds the Berksfile\n----------------------------------\n\nIf you are curious how the plugin knows to find the Berksfile in `chef-repo/environments/[ENV]/Berksfile`, you \nwant to put your Berksfile somewhere else or you have run into this error `Expected Berksfile at [/path/../Berksfile] but does not exist`, \nthis section will explain how this works and ways to tweak the path or fix your error.\n\n`load_berksfile` has an optional argument which represents the path to your Berksfile. This path can be pseduo relative (explained in a moment) \nor absolute. By default the value is `environments/[ENV_NAME]/Berksfile`.\n\nBy pseduo relative I mean that its a relative path but the plugin will check to see if the directory we are executing from partially matches \nour relative path. So if we are running knife from `/home/chef-repo/environments` and our relative path is `chef-repo/environments/dev/Berksfile` \nthe plugin will see that the relative path is partially included in our execution directory and will attempt to merge the two to come up with \n`/home/chef-repo/environments/dev/Berksfile`. If we can't make any match at all we attempt to guess the path by just joining the relative path \nwith our execution directory.\n\nSo why do we do this? Well the only way to use this plugin is if your environment is in Ruby format. Chef's `knife from file ...` uses Ruby's\n`instance_eval` in order to do this. This means the code on Chef's end effectively looks like this,\n\n    env.instance_eval(IO.read(env_ruby_file))\n\nwhich means that any context about the location of the environment file is lost. So we have no great way to discern the location of our environment \nRuby file, so instead we guess.\n".freeze
  s.email = ["bryan.baugher@cerner.com".freeze]
  s.homepage = "http://github.com/bbaugher/chef-berksfile-env".freeze
  s.licenses = ["MIT".freeze]
  s.rubygems_version = "3.2.22".freeze
  s.summary = "A Chef plugin to lock down your Chef Environment with a Berksfile".freeze

  s.installed_by_version = "3.2.22" if s.respond_to? :installed_by_version

  if s.respond_to? :specification_version then
    s.specification_version = 4
  end

  if s.respond_to? :add_runtime_dependency then
    s.add_runtime_dependency(%q<berkshelf>.freeze, [">= 4.0", "< 8.0"])
    s.add_runtime_dependency(%q<chef>.freeze, [">= 12.0", "< 15.0"])
    s.add_development_dependency(%q<bundler>.freeze, ["~> 1.6"])
    s.add_development_dependency(%q<rake>.freeze, ["~> 0.9"])
    s.add_development_dependency(%q<octokit>.freeze, ["~> 3.0"])
  else
    s.add_dependency(%q<berkshelf>.freeze, [">= 4.0", "< 8.0"])
    s.add_dependency(%q<chef>.freeze, [">= 12.0", "< 15.0"])
    s.add_dependency(%q<bundler>.freeze, ["~> 1.6"])
    s.add_dependency(%q<rake>.freeze, ["~> 0.9"])
    s.add_dependency(%q<octokit>.freeze, ["~> 3.0"])
  end
end
